% Constraint function for 0.5 * xx' * QQ * xx + vv' * xx + cc >= 0 constraint
%
% aa is the normal vector
% bb is the bias scalar
% xx is the current iterate
%
% value is the constraint value at xx
% gradient is the gradient at xx
% hessian is the hessian at xx
%
function [ value, gradient, hessian ] = constraint_quadratic( QQ, vv, cc, xx )

	value = 0.5 * xx' * QQ * xx + vv' * xx + cc;

	if ( nargout > 1 )

		%gradient = ( TODO: gradient );

		if ( nargout > 2 )
			%hessian = ( TODO: hessian );
		end
	end

end
