QQ = zeros( 5 );
vv = [ 170; 160; 175; 180; 195 ];
AA = [ 1, 0, 0, 0, 0 ; 1, 1, 0, 0, 0 ; 1, 1, 0, 0, 0 ; 1, 1, 1, 0, 0 ; 0, 1, 1, 0, 0 ; 0, 0, 1, 1, 0 ; 0, 0, 1, 1, 0 ; 0, 0, 0, 1, 0 ; 0, 0, 0, 1, 1, ; 0, 0, 0, 0, 1 ; 1, 0, 0, 0, 0 ; 0, 1, 0, 0, 0 ; 0, 0, 1, 0, 0 ; 0, 0, 0, 1, 0 ; 0, 0, 0, 0, 1 ];
bb = [ -48; -79; -65; -87; -64; -73; -82; -43; -52; -15; -0; -0; -0; -0; -0 ];

constraints = {};
for ii = 1:length( bb )
	constraints = [ constraints, { @( xx ) constraint_quadratic( QQ, AA( ii, : )', bb( ii ), xx ) } ];
end

initial_xx = [ 100; 100; 100; 100; 100 ];
newton_epsilon = 1e-8;
epsilon = 1e-4;

mm = length( bb );
lower_mu = 1 + 1 / sqrt( mm );
upper_mu = mm / epsilon;
delta_mu = 2;
initial_tt = 1;

ff = @( xx ) objective_quadratic( QQ, vv, xx );
line_search = @( ff, xx, direction ) line_search_backtracking( ff, xx, direction, 0.4, 0.9 );


mus = [];
iterations = [];

mu = lower_mu;
while ( mu <= upper_mu )

	mus = [ mus, mu ];
	[ xx, newton_iterations ] = algorithm_log_barrier( ff, constraints, initial_xx, initial_tt, mu, line_search, newton_epsilon, epsilon, mm );
	iterations = [ iterations, sum( newton_iterations ) ];

	mu = mu * delta_mu;

end


handle_constant = semilogx( mus, iterations, 'r-o' );
xlabel( '\mu' );
ylabel( 'total Newton iterations' );
hold off;
