QQ = [ 5, 2; 2, 2 ];
vv = [ 21; 13 ];
AA = [ 2, 1 ; 2, -5 ; -1, 1 ];
bb = [ 8; 10; 3 ];
mm = 2 + length( bb );

initial_xx = [ 0; 0 ];
epsilon = 1e-8;

mu = sqrt( 2 );
lower_tt = 0.1249;
upper_tt = 2;

line_search = @( ff, xx, direction ) line_search_backtracking( ff, xx, direction, 0.4, 0.9 );


tts = [];
gd_iterations = [];
newton_iterations = [];

tt = lower_tt;
while ( tt <= upper_tt )

	ff = @( xx ) objective_quadratic_log_barrier( QQ, vv, AA, bb, xx, tt );

	tts = [ tts, tt ];
	[ xx, values ] = algorithm_gd( ff, initial_xx, line_search, epsilon );
	gd_iterations = [ gd_iterations, length( values ) - 1 ];
	[ xx, values ] = algorithm_newton( ff, initial_xx, line_search, epsilon );
	newton_iterations = [ newton_iterations, length( values ) - 1 ];

	tt = tt * mu;

end


handle_gd = plot( tts, gd_iterations, 'r-o' );
hold on;
handle_newton = plot( tts, newton_iterations, 'm-o' );
legend( [ handle_gd, handle_newton ], 'GD', 'Newton' );
xlabel( 't' );
ylabel( 'iterations' );
hold off;
