% Quadratic objective
%
% QQ is the Hessian matrix
% vv is the vector of linear coefficients
% xx is the current iterate
%
% value is the function value at xx
% gradient is the gradient at xx
% hessian is the hessian at xx
%
function [ value, gradient, hessian ] = objective_quadratic( QQ, vv, xx )

	value = 0.5 * xx' * QQ * xx + vv' * xx;

	if ( nargout > 1 )

		gradient = QQ * xx + vv;

		if ( nargout > 2 )
			hessian = QQ;
		end
	end

end
